﻿;********************
;*  Remote Control  *
;*        By        *
;*   OldNESJunkie   *
;*    07/03/2015    *
;********************
;**************************************************************************
;*             Created with the following libraries and code              *
;*                                                                        *
;*                           COMate+ by srod                              *
;*                         Droopylib by Droopy                            *
;*         ListIcon search by FloHimself (updated by blbltheworm)         *
;*          ListIcon Sort by (Unknown) (Rewritten by netmaestro)          *
;*        Based on the original ZenControl code for VB by (Unknown)       *
;*                       Services code by TeddyLM                         *
;*                                 with                                   *
;*               other code pulled from the PureBasic forums              *
;**************************************************************************



;{ Create structures
Structure nslist
   myhostname.s
   mydescription.s
EndStructure
Structure LVWSORT
   hWndListView.l ; Fensterhandle des ListView-Controls
   SortKey.l ; Spalte, die sortiert werden soll
   SortType.b ; Typ der zu sortierenden Daten
   SortOrder.b ; Sortierrichtung
   DateFormat.s ; Mask for 'ParseDate'
EndStructure
;}

;{ Create global variables
Global NewList nslist.nslist()
Global flip3, flip4, flip5, flip6, flip7, flip8
Global lastx.i, lasty.i
Global PasswordHash.s
;}

;{ Include external libraries
XIncludeFile "Includes\COMatePlus.pbi"
#COMATE_NOINCLUDEATL = 1
#COMATE_NOERRORREPORTING = 1
XIncludeFile #PB_Compiler_Home+"hmod\DroopyLib.pbi"
UseModule DroopyLib
#SERVICES_ACTIVE_DATABASE = "ServicesActive"
;}

;{ Enumerate all windows and controls
Enumeration
#Window_0
#Menu_0
#PopUp_Menu
#Hosts_List
#Text_HostName
#String_HostName
#Text_Description
#String_Description
#Connect_Button
EndEnumeration

Enumeration ; Type of Column Sort
#SortString
#SortNumeric
#SortFloat
#SortDate
#SortAutoDetect
EndEnumeration

Enumeration ; Column Sort States
#NoSort   ; keine Sortierung
#AscSort  ; Aufsteigende Sortierung
#DescSort ; Absteigende Sortierung
EndEnumeration
;}

;{ Procedures
Procedure LIG_AlignColumn(gadget, index, format)
       ; by Danilo, 15.12.2003 - english chat (for 'Karbon')
       ; 20130615..nalor..modified
       
       ; change text alignment for columns
       ; #LVCFMT_LEFT / #LVCFMT_CENTER / #LVCFMT_RIGHT
       
       Protected lvc.LV_COLUMN
       lvc\mask = #LVCF_FMT
       lvc\fmt = format
       
       SendMessage_(GadgetID(gadget), #LVM_SETCOLUMN, index, @lvc)
EndProcedure

Procedure LIG_SetColumnWidth(gadget,index,new_width)
       ; by Danilo, 15.12.2003 - english chat (for 'Karbon')
       ;
       ; change column header width
       ;
       SendMessage_(GadgetID(gadget),#LVM_SETCOLUMNWIDTH,index,new_width)
EndProcedure

Procedure LIG_SetSortIcon(ListGadget.i, Column.i, SortOrder.i)
    ; http://stackoverflow.com/questions/254129/how-To-i-display-a-sort-arrow-in-the-header-of-a-List-view-column-using-c   
       Protected ColumnHeader.i
       Protected ColumnCount.i
       Protected hditem.HD_ITEM
       Protected Cnt.i
       
       ColumnHeader=SendMessage_(GadgetID(ListGadget), #LVM_GETHEADER, 0, 0)
         
       ColumnCount=SendMessage_(ColumnHeader, #HDM_GETITEMCOUNT, 0, 0)
       
       For Cnt=0 To ColumnCount-1
          hditem\mask=#HDI_FORMAT
         
          If SendMessage_(ColumnHeader, #HDM_GETITEM, Cnt, @hditem)=0
             Debug "ERROR! LIG_SetSortIcon 1"
          EndIf
         
          hditem\mask=#HDI_FORMAT
          If (Cnt=Column And SortOrder<>#NoSort)
             Select SortOrder
                Case #AscSort ; wenn aufsteigend sortiert werden soll
                   hditem\fmt& ~#HDF_SORTDOWN
                   hditem\fmt|#HDF_SORTUP
                   Debug "sortup"
                Case #DescSort
                   hditem\fmt& ~#HDF_SORTUP
                   hditem\fmt|#HDF_SORTDOWN               
                   Debug "sortdown"
             EndSelect
          Else
             hditem\fmt& ~#HDF_SORTUP
             hditem\fmt& ~#HDF_SORTDOWN
          EndIf

          If (SendMessage_(ColumnHeader, #HDM_SETITEM, Cnt, @hditem)=0)
             Debug "ERROR! LIG_SetSortIcon 2"
          EndIf
         
       Next
EndProcedure

Procedure.b LIG_GetSortOrder(ListGadget.i, Column.i)
       Protected ColumnHeader.i
       Protected hditem.HD_ITEM
       Protected RetVal.b
       
       ColumnHeader=SendMessage_(GadgetID(ListGadget), #LVM_GETHEADER, 0, 0)
         
       hditem\mask=#HDI_FORMAT
       
       If SendMessage_(ColumnHeader, #HDM_GETITEM, Column, @hditem)
          If (hditem\fmt&#HDF_SORTUP)=#HDF_SORTUP
             Debug "sortup"
             RetVal=#AscSort
          ElseIf (hditem\fmt&#HDF_SORTDOWN)=#HDF_SORTDOWN
             Debug "sortdown"
             RetVal=#DescSort
          Else
             Debug "nosort"
             RetVal=#NoSort
          EndIf
         
       Else
          Debug "ERROR! LIG_GetSortOrder"
          RetVal=-1
         
       EndIf
       
       ProcedureReturn RetVal

EndProcedure

Procedure LIG_EnsureVisible(Gadget.i, Line.i)
       ; makes sure the line is visible
       
       SendMessage_(GadgetID(Gadget), #LVM_ENSUREVISIBLE, Line, #True)
       
EndProcedure

Procedure.b IsNumChar(*Text, Position.i=1)
       Select Asc(PeekS(*Text+(Position-1)*SizeOf(Character), 1))
          Case 48 To 57
             ProcedureReturn #True
          Default
             ProcedureReturn #False
       EndSelect
       
EndProcedure

Procedure.l CompareStrings(*sEntry1, *sEntry2, SortOrder.b)
       ; ' -----------------------------------------------------
       ; ' Gibt zurück, ob das erste der beiden unterschiedlichen
       ; ' Elemente nach Maßgabe des Parameters SortOrder größer
       ; ' (1 bei aufsteigender Sortierung) oder kleiner (-1 bei
       ; ' aufsteigender Sortierung) als das zweite Element ist.
       ; ' Gleiche Elemente wurden bereits in CompareFunc ausge-
       ; ' schlossen; für sie wäre sonst 0 zurückzugeben.
       ; ' -----------------------------------------------------
       ; ' Rückgabewert je nach erwünschter Sortierung:
       
       If SortOrder=#AscSort
          ; Aufsteigende Sortierung zweier unterschiedlicher Strings
          If CompareMemoryString(*sEntry1, *sEntry2, #PB_String_NoCase)=#PB_String_Lower
             ProcedureReturn -1
          Else
             ProcedureReturn 1
          EndIf
       Else ; Absteigende Sortierung
          If CompareMemoryString(*sEntry1, *sEntry2, #PB_String_NoCase)=#PB_String_Greater
             ProcedureReturn -1
          Else
             ProcedureReturn 1
          EndIf
       EndIf
       
EndProcedure

Procedure.l CompareNumbers(sEntry1.s, sEntry2.s, SortOrder.b)
       ; ' -----------------------------------------------------
       ; ' Gibt zurück, ob das erste der beiden unterschiedlichen
       ; ' Elemente nach Maßgabe des Parameters SortOrder größer
       ; ' (1 bei aufsteigender Sortierung) oder kleiner (-1 bei
       ; ' aufsteigender Sortierung) als das zweite Element ist.
       ; ' Gleiche Elemente wurden bereits in CompareFunc ausge-
       ; ' schlossen; für sie wäre sonst 0 zurückzugeben.
       ; ' -----------------------------------------------------
       ; ' Rückgabewert je nach erwünschter Sortierung:
       
       If SortOrder=#AscSort
          ; Aufsteigende Sortierung zweier unterschiedlicher Zahlen
          If Val(sEntry1)<Val(sEntry2)
             ProcedureReturn -1
          Else
             ProcedureReturn 1
          EndIf
       Else ; Absteigende Sortierung
          If Val(sEntry1)>Val(sEntry2)
             ProcedureReturn -1
          Else
             ProcedureReturn 1
          EndIf
       EndIf
       
EndProcedure

Procedure.l CompareFloat(sEntry1.s, sEntry2.s, SortOrder.b)
       ; ' -----------------------------------------------------
       ; ' Gibt zurück, ob das erste der beiden unterschiedlichen
       ; ' Elemente nach Maßgabe des Parameters SortOrder größer
       ; ' (1 bei aufsteigender Sortierung) oder kleiner (-1 bei
       ; ' aufsteigender Sortierung) als das zweite Element ist.
       ; ' Gleiche Elemente wurden bereits in CompareFunc ausge-
       ; ' schlossen; für sie wäre sonst 0 zurückzugeben.
       ; ' -----------------------------------------------------
       ; ' Rückgabewert je nach erwünschter Sortierung:
       
       ReplaceString(sEntry1, ",", ".", #PB_String_InPlace, 1, 1) ; ersetze Dezimalkomma durch Punkt, damit ValF korrekt arbeitet
       ReplaceString(sEntry2, ",", ".", #PB_String_InPlace, 1, 1)
         
       If SortOrder=#AscSort
          ; Aufsteigende Sortierung zweier unterschiedlicher Zahlen
          If ValF(sEntry1)<ValF(sEntry2)
             ProcedureReturn -1
          Else
             ProcedureReturn 1
          EndIf
       Else ; Absteigende Sortierung
          If ValF(sEntry1)>ValF(sEntry2)
             ProcedureReturn -1
          Else
             ProcedureReturn 1
          EndIf
       EndIf         
       
EndProcedure

Procedure.l CompareDate(sEntry1.s, sEntry2.s, SortOrder.b, sDateMask.s)
       ; ' -----------------------------------------------------
       ; ' Gibt zurück, ob das erste der beiden unterschiedlichen
       ; ' Elemente nach Maßgabe des Parameters SortOrder größer
       ; ' (1 bei aufsteigender Sortierung) oder kleiner (-1 bei
       ; ' aufsteigender Sortierung) als das zweite Element ist.
       ; ' Gleiche Elemente wurden bereits in CompareFunc ausge-
       ; ' schlossen; für sie wäre sonst 0 zurückzugeben.
       ; ' -----------------------------------------------------
       ; ' Rückgabewert je nach erwünschter Sortierung:
       
       If SortOrder=#AscSort
          ; Aufsteigende Sortierung zweier unterschiedlicher Zahlen
          If ParseDate(sDateMask, sEntry1)<ParseDate(sDateMask, sEntry2)
             ProcedureReturn -1
          Else
             ProcedureReturn 1
          EndIf
       Else ; Absteigende Sortierung
          If ParseDate(sDateMask, sEntry1)>ParseDate(sDateMask, sEntry2)
             ProcedureReturn -1
          Else
             ProcedureReturn 1
          EndIf
       EndIf         
       
EndProcedure

Procedure.s LvwGetText(*ListViewSort.LVWSORT, lParam.l)
       ; ' -----------------------------------------------------
       ; ' Ermittelt aus dem Fensterhandle des ListView-
       ; ' Steuerelements, der in ListViewSort.SortKey
       ; ' angegebenen (nullbasierten) Spalte im ListView
       ; ' und der an CompareFunc übergebenen Werte lParam1/2
       ; ' die davon repräsentierten Zelleninhalte.
       ; ' -----------------------------------------------------
       
       ; 20130623..nalor..Check if AllocateMemory succeeds
       ;                  freememory at the end (kudos to 'Little John')
       
       Protected udtFindInfo.LV_FINDINFO
       Protected udtLVItem.LV_ITEM
       Protected lngIndex.l
       Protected *baBuffer
       Protected lngLength.l
       Protected RetVal.s=""

       *baBuffer=AllocateMemory(512)
       
       If (*baBuffer)
          ; Auf Basis des Index den Text der Zelle auslesen:
          udtLVItem\mask=#LVIF_TEXT
          udtLVItem\iSubItem=*ListViewSort\SortKey
          udtLVItem\pszText=*baBuffer
          udtLVItem\cchTextMax=(512/SizeOf(Character))-1
         
          lngLength = SendMessage_(*ListViewSort\hWndListView, #LVM_GETITEMTEXT, lParam, @udtLVItem)
         
          ; Byte-Array in passender Länge als String-Rückgabewert kopieren:
          If lngLength > 0
             RetVal = PeekS(*baBuffer, lngLength)
          EndIf
          FreeMemory(*baBuffer)
       Else
          Debug "ERROR!! Allocating memory (LvwGetText)"
       EndIf
       
       ProcedureReturn RetVal
EndProcedure

Procedure.l CompareFunc(lParam1.l, lParam2.l, lParamSort.l)
       ; ' -----------------------------------------------------
       ; ' Vergleichsfunktion CompareFunc
       ; ' -----------------------------------------------------
       ; ' Verglichen werden jeweils zwei Elemente der zu
       ; ' sortierenden Spalte des ListView-Steuerelements,
       ; ' die über lParam1 und lParam2 angegeben werden.
       ; ' Hierbei wird über den Rückgabewert der Funktion
       ; ' bestimmt, welches der beiden Elemente als größer
       ; ' gelten soll (hier für Aufwärtssortierung):
       ; ' * Element 1 < Element 2: Rückgabewert < 0
       ; ' * Element 1 = Element 2: Rückgabewert = 0
       ; ' * Element 1 > Element 2: Rückgabewert > 0
       ; ' -----------------------------------------------------
       Protected *ListViewSort.LVWSORT
       Protected sEntry1.s
       Protected sEntry2.s
       Protected vCompare1.s ; As Variant
       Protected vCompare2.s ; As Variant
       
       ; In lParamSort von SortListView als Long-Pointer übergebene LVWSORT-Struktur abholen, um auf deren
       ; Werte zugreifen zu können:
       
       *ListViewSort=lParamSort
       
       ; Die Werte der zu vergleichenden Elemente werden mithilfe der privaten Funktion LvwGetText aus
       ; den Angaben lParam1 und lParam2 ermittelt:
       sEntry1 = LvwGetText(*ListViewSort, lParam1)
       sEntry2 = LvwGetText(*ListViewSort, lParam2)

       ; Sind die Elemente gleich, kann die Funktion sofort mit dem aktuellen Rückgabewert 0
       ; verlassen werden:
       If sEntry1 = sEntry2
          ProcedureReturn 0
       EndIf
       
       ; Für die Sortierung wird unterschieden zwischen Zahlen, Fließkommazahlen und allgemeinen Strings. Hierfür
       ; steht jeweils eine separate, private Vergleichsfunktion zur Verfügung.
       
       Select *ListViewSort\SortType
          Case #SortNumeric ; ' Spalteninhalte sind Zahlen
             ProcedureReturn CompareNumbers(sEntry1, sEntry2, *ListViewSort\SortOrder)
          Case #SortFloat ; ' Spalteninhalte sind Zahlen mit Nachkommastellen
             ProcedureReturn CompareFloat(sEntry1, sEntry2, *ListViewSort\SortOrder)
          Case #SortString;  ' Spalteninhalte sind Strings
             ProcedureReturn CompareStrings(@sEntry1, @sEntry2, *ListViewSort\SortOrder)
          Case #SortDate
             ProcedureReturn CompareDate(sEntry1, sEntry2, *ListViewSort\SortOrder, *ListViewSort\DateFormat)
       EndSelect
EndProcedure

Procedure.s GetDateFormat(Date.s)
       Debug "GetDateFormat >"+Date+"<"
       
       Protected Diff.i
       
       Diff=Len(Date)-CountString(Date, "0")-CountString(Date, "1")-CountString(Date, "2")-CountString(Date, "3")-CountString(Date, "4")-CountString(Date, "5")-CountString(Date, "6")-CountString(Date, "7")-CountString(Date, "8")-CountString(Date, "9")   
       
       Select Diff
          Case 2
             If Len(Date)=10 ; Date 'dd.mm.yyyy', 'mm.dd.yyyy' or 'yyyy.mm.dd'

                If (Not IsNumChar(@Date, 5) And Not IsNumChar(@Date, 8)) ; yyyy.mm.dd
                   ProcedureReturn "" ; faster to sort as string
                   
                ElseIf (Not IsNumChar(@Date, 3) And Not IsNumChar(@Date, 6)) ; dd.mm.yyyy or mm.dd.yyyy
                   If Val(Mid(Date, 4, 2))>12 ; is it mm.dd.yyyy?
                      ProcedureReturn "%mm"+Mid(Date, 3, 1)+"%dd"+Mid(Date, 6, 1)+"%yyyy"
                   Else ; default is dd.mm.yyyy
                      ProcedureReturn "%dd"+Mid(Date, 3, 1)+"%mm"+Mid(Date, 6, 1)+"%yyyy"
                   EndIf
                   
                Else
                   ProcedureReturn "" ; not a date - sort as string
                EndIf
             Else
                ProcedureReturn "" ; not a date - sort as string
             EndIf
             
          Case 4
             If Len(Date)=16 ;yyyy-mm-dd hh:mm, dd-mm-yyyy hh:mm or mm-dd-yyyy hh:mm
               
                If (Not IsNumChar(@Date, 5) And Not IsNumChar(@Date, 8)) ; yyyy.mm.dd xxxxx
                   ProcedureReturn "" ; faster to sort as string
                   
                ElseIf (Not IsNumChar(@Date, 3) And Not IsNumChar(@Date, 6)) ; dd.mm.yyyy hh:mm or mm.dd.yyyy hh:mm
                   If Val(Mid(Date, 4, 2))>12 ; is it mm.dd.yyyy?
                      ProcedureReturn "%mm"+Mid(Date, 3, 1)+"%dd"+Mid(Date, 6, 1)+"%yyyy"+Mid(Date, 11, 1)+"%hh"+Mid(Date, 14, 1)+"%ii"
                   Else ; default is dd.mm.yyyy
                      ProcedureReturn "%dd"+Mid(Date, 3, 1)+"%mm"+Mid(Date, 6, 1)+"%yyyy"+Mid(Date, 11, 1)+"%hh"+Mid(Date, 14, 1)+"%ii"
                   EndIf
                   
                Else
                   ProcedureReturn "" ; not a date - sort as string
                EndIf
             Else
                ProcedureReturn "" ; not a date - sort as string
             EndIf           
                   
          Case 5 ; 5 other chars, possibly DateTime?
             
             If Len(Date)=19 ;yyyy-mm-dd hh:mm, dd-mm-yyyy hh:mm or mm-dd-yyyy hh:mm
               
                If (Not IsNumChar(@Date, 5) And Not IsNumChar(@Date, 8)) ; yyyy.mm.dd xxxxx
                   ProcedureReturn "" ; faster to sort as string
                   
                ElseIf (Not IsNumChar(@Date, 3) And Not IsNumChar(@Date, 6)) ; dd.mm.yyyy hh:mm or mm.dd.yyyy hh:mm
                   If Val(Mid(Date, 4, 2))>12 ; is it mm.dd.yyyy?
                      ProcedureReturn "%mm"+Mid(Date, 3, 1)+"%dd"+Mid(Date, 6, 1)+"%yyyy"+Mid(Date, 11, 1)+"%hh"+Mid(Date, 14, 1)+"%ii"+Mid(Date, 17, 1)+"%ss"
                   Else ; default is dd.mm.yyyy
                      ProcedureReturn "%dd"+Mid(Date, 3, 1)+"%mm"+Mid(Date, 6, 1)+"%yyyy"+Mid(Date, 11, 1)+"%hh"+Mid(Date, 14, 1)+"%ii"+Mid(Date, 17, 1)+"%ss"
                   EndIf
                   
                Else
                   ProcedureReturn "" ; not a date - sort as string
                EndIf
             Else
                ProcedureReturn "" ; not a date - sort as string
             EndIf
             
          Default
             ProcedureReturn ""
       EndSelect
             
EndProcedure

Procedure SortListView(hWndListView.l, SortKey.l, SortType.b, SortOrder.b)
    ; ' -----------------------------------------------------
    ; ' Öffentlich aufzurufende Prozedur SortListView, die
    ; ' für die individuelle Sortierung einer ListView-Spalte
    ; ' sorgt.
    ; ' -----------------------------------------------------
    ; ' hWndListView: Fensterhandle des ListView-Steuerelements
    ; ' SortKey:      Spalte (nullbasiert), die sortiert werden
    ; '               soll (= Spaltennummer - 1).
    ; ' SortType:     stString, um Strings zu sortieren (Standardwert)
    ; '               stDate, um Datumsangaben zu sortieren
    ; '               stNumeric, um Zahlen zu sortieren
    ; ' SortOrder:    lvwAscending für aufsteigende Sortierung (Std.)
    ; '               lvwDescending für absteigende Sortierung
    ; ' -----------------------------------------------------
       
       Protected udtLVWSORT.LVWSORT
       Protected sDateFormat.s, sTemp.s, GadId.i
       
       If SortType=#SortDate
          GadId=GetDlgCtrlID_(hWndListView)
          sDateFormat=GetDateFormat(GetGadgetItemText(GadId, 0, SortKey))
         
          If sDateFormat=""
             SortType=#SortString
          Else
             sTemp=GetDateFormat(GetGadgetItemText(GadId, CountGadgetItems(GadId)-1, SortKey))
             If sTemp=""
                SortType=#SortString
             Else
                If sTemp<>sDateFormat
                   If Left(sTemp, 3)="%mm" ; new format starts with %mm (.dd.yyyy) - if this US format is detected it has higher prio
                      sDateFormat=sTemp
                   EndIf
                EndIf
                sTemp=GetDateFormat(GetGadgetItemText(GadId, CountGadgetItems(GadId)/2, SortKey))
                If sTemp=""
                   SortType=#SortString
                Else
                   If sTemp<>sDateFormat
                      If Left(sTemp, 3)="%mm" ; new format starts with %mm (.dd.yyyy) - if this US format is detected it has higher prio
                         sDateFormat=sTemp
                      EndIf
                   EndIf
                EndIf   
             EndIf         
          EndIf
          udtLVWSORT\DateFormat=sDateFormat
          Debug "Final DateFormat >"+sDateFormat+"<"
       EndIf
       
       ; Übergebene Informationen in einer LVWSORT-Struktur zusammenfassen:
       udtLVWSORT\hWndListView=hWndListView
       udtLVWSORT\SortKey=SortKey
       udtLVWSORT\SortOrder=SortOrder
       udtLVWSORT\SortType=SortType   
       
       ; Eigene Sortierfunktionalität in der Funktion CompareFunc verwenden: Die Informationen der
       ; LVWSORT-Struktur wird mithilfe eines Zeigers auf die Variable udtLVWSORT beigegeben:
       SendMessage_(hWndListView, #LVM_SORTITEMSEX, @udtLVWSORT, @CompareFunc())
EndProcedure   

Procedure.b DetectOrderType(sText.s)
       
       Protected Diff.i
       
       Diff=Len(sText)-CountString(sText, "0")-CountString(sText, "1")-CountString(sText, "2")-CountString(sText, "3")-CountString(sText, "4")-CountString(sText, "5")-CountString(sText, "6")-CountString(sText, "7")-CountString(sText, "8")-CountString(sText, "9")   
       
       Select Diff
          Case 0 ; es sind nur Ziffern
             ProcedureReturn #SortNumeric
             
          Case 1 ; nur 1 anderes Zeichen
             If (CountString(sText, ",")>0 Or CountString(sText, ".")>0)
                ProcedureReturn #SortFloat
             ElseIf (Left(sText, 1)="$" Or Left(sText, 1)="%") ; es ist eine HEX oder Binär Zahl
                ProcedureReturn #SortNumeric
             Else
                ProcedureReturn #SortString
             EndIf
             
          Case 2 ; 2 andere Zeichen - evtl. Datum?
             
             If (Len(sText)=10 And
                 Not IsNumChar(@sText, 3) And Not IsNumChar(@sText, 6))
                ; dd-mm-yyyy or mm-dd-yyyy
                ProcedureReturn #SortDate
             Else
                ; yyyy-mm-dd
                ProcedureReturn #SortString
             EndIf
             
          Case 4 ; 4 other chars, possibly DateTime?
             
             If (Len(sText)=16 And
                 Not IsNumChar(@sText, 3) And Not IsNumChar(@sText, 6) And
                 Not IsNumChar(@sText, 11) And Not IsNumChar(@sText, 14))
                ;dd-mm-yyyy hh:mm or mm-dd-yyyy hh:mm
                ProcedureReturn #SortDate
             Else
                ProcedureReturn #SortString
             EndIf
             
          Case 5 ; 5 other chars, possibly DateTime?
             
             If (Len(sText)=19 And
                 Not IsNumChar(@sText, 3) And Not IsNumChar(@sText, 6) And
                 Not IsNumChar(@sText, 11) And Not IsNumChar(@sText, 14) And Not IsNumChar(@sText, 17))
                ;dd-mm-yyyy hh:mm:ss or mm-dd-yyyy hh:mm:ss
                ProcedureReturn #SortDate
             Else
                ProcedureReturn #SortString
             EndIf         
       
          Default
             ProcedureReturn #SortString
             
       EndSelect

EndProcedure

Procedure LIG_SortColumn(GadId.l, Column.l, OrderType.b=#SortAutoDetect)
       
       Protected ColCnt.i
       Protected Order.i
       Protected iStartT.i
       Protected iEndT.i
       Protected Temp.b
       
       Debug "LIG_SortColumn >"+Str(GadId)+"< Column >"+Str(Column)+"<"
       
       Select LIG_GetSortOrder(GadId, Column)
          Case #NoSort, #DescSort
             Order=#AscSort
          Case #AscSort
             Order=#DescSort
       EndSelect
       
       iStartT=ElapsedMilliseconds()
       
       If OrderType=#SortAutoDetect ; detect it automatically - check first, last and middle item of list
          OrderType=DetectOrderType(GetGadgetItemText(GadId, 0, Column))
          If (OrderType=DetectOrderType(GetGadgetItemText(GadId, CountGadgetItems(GadId)-1, Column)))
             If (OrderType<>DetectOrderType(GetGadgetItemText(GadId, CountGadgetItems(GadId)/2, Column)))
                Debug "Different OrderType - use SortString 2"
                OrderType=#SortString
             EndIf
          Else
             Debug "Different OrderType - use SortString"
             OrderType=#SortString
          EndIf
       EndIf   
       
       SortListView(GadgetID(GadId), Column, OrderType, Order)
       
       iEndT=ElapsedMilliseconds()
       
       Debug "Duration >"+StrF( (iEndT-iStartT)/1000, 2)+"<"
       
       LIG_SetSortIcon(GadId, Column, Order)
       
       If (GetGadgetState(GadId)>-1)
          LIG_EnsureVisible(GadId, GetGadgetState(GadId))
       EndIf
       
EndProcedure

Procedure ColumnClickCallback(hWnd, uMsg, wParam, lParam)
   
    Protected *msg.NM_LISTVIEW

    If uMsg=#WM_NOTIFY
       *msg=lParam
       If *msg\hdr\code=#LVN_COLUMNCLICK                     
          LIG_SortColumn(GetDlgCtrlID_(*msg\hdr\hwndfrom), *msg\iSubItem) ;, GetColumnOrderType(GetDlgCtrlID_(*msg\hdr\hwndfrom), *msg\iSubItem))
       EndIf
    EndIf
    ProcedureReturn #PB_ProcessPureBasicEvents
 
EndProcedure

Procedure CreateFiles()
CreateDirectory("Viewer")
CreateDirectory("Server")
CreateFile(1,"Viewer\tvnviewer.exe")
WriteData(1,?viewerstart,?viewerend-?viewerstart)
CloseFile(1)

CreateFile(2,"Server\tvnserver.exe")
WriteData(2,?serverstart,?serverend-?serverstart)
CloseFile(2)

CreateFile(3,"Server\hookldr.exe")
WriteData(3,?hookloadstart,?hookloadend-?hookloadstart)
CloseFile(3)

CreateFile(4,"Server\screenhooks64.dll")
WriteData(4,?screenhookstart,?screenhookend-?screenhookstart)
CloseFile(4)
EndProcedure

Procedure.l CopyDir(FromLoc.s, Toloc.s)
  Switches.SHFILEOPSTRUCT ;Windows API Structure
  ;The filename needs to be double null-terminated.
  temp1$=Space(#MAX_PATH+SizeOf(character))
  RtlZeroMemory_(@temp1$, #MAX_PATH+SizeOf(character))
  PokeS(@temp1$, FromLoc)
  temp2$=Space(#MAX_PATH+SizeOf(character))
  RtlZeroMemory_(@temp2$, #MAX_PATH+SizeOf(character))
  PokeS(@temp2$, ToLoc)
;  File_Dest.s = Toloc +Chr(0)+Chr(0)
  Switches\wFunc = #FO_COPY
  Switches\pFrom = @temp1$
  Switches\pTo = @temp2$
  Switches\fFlags = #FOF_NOCONFIRMATION

  Result.l = SHFileOperation_(@Switches)   

  ; If cancel was pressed then result will NOT be zero (0)
EndProcedure

Procedure.s CreatePassword()
strInputString.s
strCode.s
intNameLength.i
intRnd.i

strInputString = "ABCDEF0123456789" ;Characters To choose from To generate random string
intNameLength = 16 ;Define length of random string

;Generate the random string
For intStep = 1 To intNameLength
   intRnd = Random(16)
   strCode = strCode + Mid(strInputString, intRnd, 1)
Next
;Return the string
PasswordHash.s = strCode
EndProcedure

Procedure ClearHosts()
 clearallhosts=MessageRequester("Clear All Hosts","Do you wish to clear all hosts?",#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)
  If clearallhosts=#PB_MessageRequester_Yes
    ClearGadgetItems(#Hosts_List)
     SetGadgetText(#String_HostName,"")
      SetGadgetText(#String_Description,"")
       DeleteFile("hosts.dat",#PB_FileSystem_Force)
  EndIf
EndProcedure

Procedure CountListiconColumn(gadget, maxcolumn, keyword.s)
If IsGadget(gadget)
  AddGadgetColumn(gadget, maxcolumn, keyword, 0)
    For i=0 To maxcolumn
      If GetGadgetItemText(gadget, -1, i)=keyword
        Break
      EndIf   
    Next
  RemoveGadgetColumn(gadget, i)
  ProcedureReturn i
EndIf
EndProcedure

Procedure FillListIcon(filename.s)
   If ReadFile(0,filename)
     With nslist()
       While Eof(0)=0
         a$=ReadString(0,ReadStringFormat(0))
         p=FindString(a$,",")
         AddElement(nslist())
          \myhostname=Left(a$,p-1)
          \mydescription=Right(a$,(Len(a$)-(p)))
       Wend
     EndWith
   ForEach nslist()
     match_counter+1
      AddGadgetItem(#Hosts_List,-1, nslist()\myhostname +Chr(10)+nslist()\mydescription)
   Next
    ClearList(nslist()) 
     CloseFile(0)
   EndIf
EndProcedure

Procedure FreeWorkingMemory()
  Define  myProcessID,PHandle
  myProcessID=GetCurrentProcessId_()
  PHandle = GetCurrentProcess_();
  
  Result= SetProcessWorkingSetSize_(PHandle,-1,-1) 
  If Result
    
  Else 
    ; it failed
  EndIf
EndProcedure

Procedure InstallService(Computername$, ServiceName$, ServiceApp$)
    T_TABLE_ENTRY.SERVICE_TABLE_ENTRY
    Result = 1 
    hSCM = OpenSCManager_(Computername$, 0, #SC_MANAGER_ALL_ACCESS)
    If hSCM
        hServ = CreateService_(hSCM, ServiceName$, ServiceName$, #SERVICE_ALL_ACCESS, #SERVICE_WIN32_OWN_PROCESS, #SERVICE_DEMAND_START, #SERVICE_ERROR_NORMAL, ServiceApp$, 0, 0, 0, 0, 0)
        If hServ
            Result = 0
            CloseServiceHandle_(hServ)
        EndIf 
        CloseServiceHandle_(hSCM)
    EndIf
    ProcedureReturn Result
EndProcedure

Procedure PingHost(hostname.s)
Define.comateObject objshell
  objshell = COMate_CreateObject("WSCript.shell")
If objshell
  response$ = objshell\GetStringProperty("Run('Ping "+hostname.s+"',0, #True)")
  ;Debug response$
  objshell\Release()
EndIf
ProcedureReturn Val(response$)
EndProcedure

Procedure CreateRegKeys(pcname.s)

RegSetValue("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System","SoftwareSASGeneration","1",#REG_DWORD,pcname)
RegCreateKey("HKEY_LOCAL_MACHINE\Software\TightVNC\Server",pcname)             
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","AcceptHttpConnections","0",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","AcceptRfbConnections","1",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","AllowLoopback","0",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","AlwaysShared","0",#REG_DWORD,pcname)
If GetMenuItemState(#Menu_0,4)<>0; Disable Local Input
  RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","BlockLocalInput","1",#REG_DWORD,pcname)
Else
  RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","BlockLocalInput","0",#REG_DWORD,pcname)
EndIf
If GetMenuItemState(#Menu_0,5)<>0; View Only
  RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","BlockRemoteInput","1",#REG_DWORD,pcname)
Else
  RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","BlockRemoteInput","0",#REG_DWORD,pcname)
EndIf
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","ControlPassword","",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","DisconnectAction","0",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","DisconnectClients","1",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","EnableFileTransfers","1",#REG_DWORD,pcname);<----File Transfers are ENABLED
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","EnableUrlParams","1",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","ExtraPorts","",#REG_SZ,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","GrabTransparentWindows","1",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","HttpPort","5800",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","LocalInputPriority","0",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","LocalInputPriorityTimeout","3",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","LogLevel","0",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","LoopbackOnly","0",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","NeverShared","1",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","Password",PasswordHash,#REG_BINARY,pcname);"CDE13BD91F2653DD",#REG_BINARY,pcname);<----password: echo123
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","PollingInterval","1000",#REG_DWORD,pcname)
If GetMenuItemState(#Menu_0,3)<>0; Prompt User
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","IPAccessControl","0.0.0.0-255.255.255.255:2",#REG_SZ,pcname)
Else
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","IPAccessControl","",#REG_SZ,pcname)
EndIf
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","QueryAcceptOnTimeout","1",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","QueryTimeout","15",#REG_DWORD,pcname)
If GetMenuItemState(#Menu_0,6)<>0; Remove Wallpaper
  RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","RemoveWallpaper","1",#REG_DWORD,pcname)
Else
  RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","RemoveWallpaper","0",#REG_DWORD,pcname)
EndIf
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","RepeatControlAuthentication","0",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","RfbPort","5900",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","RunControlInterface","0",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","SaveLogToAllUsersPath","0",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","UseControlAuthentication","0",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","UseMirrorDriver","0",#REG_DWORD,pcname)
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","UseVNCAuthentication","1",#REG_DWORD,pcname);<----Turn to 0 for NO password
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","VideoClasses","",#REG_SZ,pcname) 
 RegSetValue("HKEY_LOCAL_MACHINE\Software\TightVNC\Server","VideoRecognitionInterval","3000",#REG_DWORD,pcname)

EndProcedure

Procedure RemoveHost()
 clearcurrenthost=MessageRequester("","Are you sure you wish to remove "+GetGadgetText(#Hosts_List)+" ?",#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)
   If clearcurrenthost=#PB_MessageRequester_Yes
     RemoveGadgetItem(#Hosts_List,GetGadgetState(#Hosts_List))
      CreateFile(0, "hosts.dat")
       Result = CountGadgetItems(#Hosts_List)
        COLFLAG=countlisticoncolumn(#Hosts_List,3,"")
  For lin = 0 To Result - 1;number of lines
     For col = 0 To COLFLAG - 1;number of columns
      plink$ = GetGadgetItemText(#Hosts_List,lin,col);get that LOCATION and put it in plink$
      plink$ = plink$+",";add a comma (this is a CSV file)
        plonk$ = plonk$ + plink$;add plink$ to plonk$
         ;plink$ = "";kill value in plink$
          If col=COLFLAG-1;EOL reached
            cut=Len(plonk$) - 1
             plonk$ = Left(plonk$,cut);cut off the last ","
          EndIf
       Next
       WriteStringN(0, plonk$);write the entire plonk$
       plonk$ = "";kill value in plonk$
    Next
     CloseFile(0)
   EndIf
EndProcedure

Procedure CreateConfigFile(hostname.s)
OpenFile(5,"Viewer\config.vnc")
 WriteStringN(5,"[connection]")
 WriteStringN(5,"host="+hostname)
 WriteStringN(5,"port=5900")
 WriteString(5,"password="+PasswordHash)
CloseFile(5)
EndProcedure

Procedure RunViewer()
RunProgram("Viewer\tvnviewer.exe","-optionsfile=Viewer\config.vnc","",#PB_Program_Wait)
EndProcedure

Procedure SearchListIcon(gadget, text.s)
  Protected pos, pt1.POINT, pt2.POINT
  Protected item.LVFINDINFO
  item\flags = #LVFI_STRING | #LVFI_PARTIAL
  item\psz = @text
  pos = SendMessage_(GadgetID(gadget), #LVM_FINDITEM, -1, @item)
  If pos <> -1
    SendMessage_(GadgetID(gadget), #LVM_GETITEMPOSITION, pos, @pt1) ; get point for item we want at top
    SendMessage_(GadgetID(gadget), #LVM_GETITEMPOSITION, SendMessage_(GadgetID(gadget), #LVM_GETTOPINDEX, 0, 0), @pt2) ; get point for current item at top
    SendMessage_(GadgetID(gadget), #LVM_SCROLL, 0, -(pt2\y - pt1\y)) ; scroll difference
    sItem.LVITEM\mask = #LVIF_STATE
    sItem\state = #LVIS_SELECTED
    sItem\stateMask = #LVIS_SELECTED
    SendMessage_(GadgetID(gadget), #LVM_SETITEMSTATE, pos , sItem) ; set item state as selected
  EndIf
ProcedureReturn pos
EndProcedure

Procedure SortFile(file.s)
Dim Array$(10000)
r = OpenFile(1, file)
pos=1
eof=0
While Eof(1)=0
text$ = ReadString(1)
Array$(pos) = text$
pos=pos+1
Wend
CloseFile(1)

quantity=pos-1
SortArray(Array$(),2,1,quantity)
DeleteFile(file)
OpenFile(1,file)
pos=1
Repeat
text$ = Array$(pos)
If text$<>""
WriteStringN(1,text$)
EndIf
pos=pos+1
Until pos=quantity+1
CloseFile(1)
EndProcedure

Procedure StartService(Computername$, ServiceName$)
    T_TABLE_ENTRY.SERVICE_TABLE_ENTRY
    Result = 1 
    hSCM = OpenSCManager_(Computername$, 0, #SC_MANAGER_ALL_ACCESS)
    If hSCM
        hServ = OpenService_(hSCM, ServiceName$, #SERVICE_ALL_ACCESS)
        If hServ
            If StartService_(hServ, 0, 0)
                Result = 0
            EndIf
            CloseServiceHandle_(hServ)
        EndIf
        CloseServiceHandle_(hSCM)
    EndIf
    ProcedureReturn Result
EndProcedure

Procedure StopService(Computername$, ServiceName$)
    Result = 0
    hSManager = OpenSCManager_(Computername$, #SERVICES_ACTIVE_DATABASE, #SC_MANAGER_ALL_ACCESS)
    If hSManager
        hService = OpenService_(hSManager, ServiceName$, #SERVICE_ALL_ACCESS)
        If hService
            Result = ControlService_(hService, #SERVICE_CONTROL_STOP, ServiceStat.SERVICE_STATUS)
            CloseServiceHandle_(hService)
        EndIf
        CloseServiceHandle_(hSManager)
    EndIf
    ProcedureReturn Result
EndProcedure

Procedure UninstallService(Computername$, ServiceName$)
    T_TABLE_ENTRY.SERVICE_TABLE_ENTRY
    Result = 1 
    hSCM = OpenSCManager_(Computername$, 0, #SC_MANAGER_ALL_ACCESS)
    If hSCM
        hServ = OpenService_(hSCM, ServiceName$, #SERVICE_ALL_ACCESS)
        If hServ
            If DeleteService_(hServ)
                Result = 0
            EndIf
            CloseServiceHandle_(hServ)
        EndIf
        CloseServiceHandle_(hSCM)
    EndIf
    ProcedureReturn Result
EndProcedure

Procedure DeleteFiles(hostname.s)
start:
 RunProgram("netsh","-r "+hostname+" advfirewall firewall delete rule name="+Chr(34)+"TightVNC Server"+Chr(34),"",#PB_Program_Wait|#PB_Program_Hide)
 If DeleteDirectory("\\"+hostname+"\c$\RCTemp","",#PB_FileSystem_Recursive|#PB_FileSystem_Force)=0
   sure=MessageRequester("Error","Failed to remove files on remote host."+#CRLF$+"Would you like to try again?",#PB_MessageRequester_YesNo|#MB_ICONERROR)
 EndIf
  If sure=#PB_MessageRequester_Yes
    StopService(hostname,"UxSms")
     RunProgram("taskkill","/s "+hostname+"/f /im LogonUI.exe","",#PB_Program_Hide)
      Delay(3000)
   If DeleteDirectory("\\"+hostname+"\c$\RCTemp","",#PB_FileSystem_Recursive|#PB_FileSystem_Force)=0
     Goto start
   Else
     StartService(hostname,"UxSms")
      MessageRequester("Success","Successfully removed all files from remote host",#MB_ICONINFORMATION)
   EndIf
  EndIf
EndProcedure

Procedure DeleteLocalFiles()
 DeleteFile("Viewer\tvnviewer.exe")
  DeleteFile("Server\tvnserver.exe")
   DeleteFile("Server\hookldr.exe")
    DeleteFile("Server\screenhooks64.dll")
     DeleteDirectory("Viewer","*.*")
      DeleteDirectory("Server","*.*")
       DeleteDirectory("TightVNC","*.*")
EndProcedure

Procedure ConnectHostButton()
 myhostname.s=GetGadgetText(#String_HostName)
  pingresult=PingHost(myhostname)
   If pingresult=0
     RunProgram("netsh","-r "+myhostname+" advfirewall firewall add rule name="+Chr(34)+"TightVNC Server"+Chr(34)+" dir=in action=allow protocol=TCP localport=5900 enable=yes profile=any","",#PB_Program_Wait|#PB_Program_Hide)
    ;If CopyDirectory("Server","\\"+myhostname+"\c$\RCTemp","")=0
    CreateDirectory("\\"+myhostname+"\c$\RCTemp")
     Error.b=CopyDir("Server\*.*","\\"+myhostname+"\c$\RCTemp")
    If Error.b = #True
      MessageRequester("Error","Failed to copy files to "+myhostname+"."+#CRLF$+"Make sure you are running with admin rights.",#MB_ICONERROR)
    Else
     If SearchListIcon(#Hosts_List,GetGadgetText(#String_HostName))=-1; Find if duplicate
      AddGadgetItem(#Hosts_List,0,GetGadgetText(#String_HostName)+Chr(10)+GetGadgetText(#String_Description))
       OpenFile(0,"hosts.dat",#PB_File_Append)
        WriteStringN(0,GetGadgetText(#String_HostName)+Chr(44)+GetGadgetText(#String_Description))
         CloseFile(0)
     EndIf
       SetWindowState(#Window_0,#PB_Window_Minimize)
        StartService(myhostname,"RemoteRegistry")
         CreatePassword()
          CreateConfigFile(myhostname)
          CreateRegKeys(myhostname)
           InstallService(myhostname,"TightVNC Server","C:\RCTemp\tvnserver.exe -service")
            Delay(2000)
             StartService(myhostname,"TightVNC Server")
              Delay(2000)
               RunViewer()
                Delay(2000)
                 StopService(myhostname,"TightVNC Server")
                  Delay(5000)
                   UninstallService(myhostname,"TightVNC Server")
                    RegDeleteKeyWithAllSub("HKEY_LOCAL_MACHINE\Software\TightVNC\Server",myhostname)
                     RegDeleteKey("HKEY_LOCAL_MACHINE\Software\TightVNC",myhostname)
                      StopService(myhostname,"RemoteRegistry")
                       DeleteFiles(myhostname)
                        SetWindowState(#Window_0,#PB_Window_Normal)
    EndIf
   Else
     MessageRequester("Error","Cannot connect to remote host.",#MB_ICONERROR)
   EndIf
EndProcedure

Procedure ConnectHostMouse()
 If GetGadgetText(#Hosts_List)<>""
   myhostname.s=GetGadgetText(#Hosts_List)
    SetGadgetText(#String_HostName,GetGadgetText(#Hosts_List))
     SetGadgetText(#String_Description,GetGadgetItemText(#Hosts_List,GetGadgetState(#Hosts_List),1))
      pingresult=PingHost(myhostname)
 EndIf
  If pingresult=0
    RunProgram("netsh","-r "+myhostname+" advfirewall firewall add rule name="+Chr(34)+"TightVNC Server"+Chr(34)+" dir=in action=allow protocol=TCP localport=5900 enable=yes profile=any","",#PB_Program_Wait|#PB_Program_Hide)
   ;If CopyDirectory("Server","\\"+myhostname+"\c$\RCTemp","")=0
   CreateDirectory("\\"+myhostname+"\c$\RCTemp")
    Error.b=CopyDir("Server\*.*","\\"+myhostname+"\c$\RCTemp")
   If Error.b = #True
     MessageRequester("Error","Failed to copy files to "+myhostname+"."+#CRLF$+"Make sure you are running with admin rights.",#MB_ICONERROR)
   Else
     SetWindowState(#Window_0,#PB_Window_Minimize)
      StartService(myhostname,"RemoteRegistry")
       CreatePassword()
        CreateConfigFile(myhostname)
        CreateRegKeys(myhostname)
         InstallService(myhostname,"TightVNC Server","C:\RCTemp\tvnserver.exe -service")
          Delay(2000)
           StartService(myhostname,"TightVNC Server")
            Delay(2000)
             RunViewer()
              Delay(2000)
               StopService(myhostname,"TightVNC Server")
                Delay(5000)
                 UninstallService(myhostname,"TightVNC Server")
                  RegDeleteKeyWithAllSub("HKEY_LOCAL_MACHINE\Software\TightVNC\Server",myhostname)
                   RegDeleteKey("HKEY_LOCAL_MACHINE\Software\TightVNC",myhostname)
                    StopService(myhostname,"RemoteRegistry")
                     DeleteFiles(myhostname)
                      SetWindowState(#Window_0,#PB_Window_Normal)
   EndIf
  Else
     MessageRequester("Error","Cannot connect to remote host.",#MB_ICONERROR)
  EndIf
EndProcedure
;}

;{ Create all VNC & Preference files
CreateFiles()
If OpenPreferences("prefs.dat")=0
  CreatePreferences("prefs.dat")
   OpenPreferences("prefs.dat")
    WritePreferenceInteger("PromptUser",0)
     WritePreferenceInteger("DisableRemoteInput",0)
      WritePreferenceInteger("ViewOnly",0)
       WritePreferenceInteger("RemoveWallpaper",0)
        WritePreferenceInteger("SortHosts",0)
         WritePreferenceInteger("SaveWindowPosition",0)
          WritePreferenceInteger("LastX",5)
           WritePreferenceInteger("LastY",5)
        ClosePreferences()
Else
  OpenPreferences("prefs.dat")
   promptme.i=ReadPreferenceInteger("PromptUser",0)
    noremote.i=ReadPreferenceInteger("DisableRemoteInput",0)
     nolocal.i=ReadPreferenceInteger("ViewOnly",0)
      nowallpaper.i=ReadPreferenceInteger("RemoveWallpaper",0)
       sorthosts.i=ReadPreferenceInteger("SortHosts",0)
        savepos.i=ReadPreferenceInteger("SaveWindowPosition",0)
         lastx.i=ReadPreferenceInteger("LastX",5)
          lasty.i=ReadPreferenceInteger("LastY",5)
  ClosePreferences()
EndIf
;}

;{ Create window and populate gadgets
OpenWindow(#Window_0,lastx,lasty,400,400,"Remote Control",#PB_Window_SystemMenu|#PB_Window_MinimizeGadget)
 SetWindowCallback(@ColumnClickCallback(), #Window_0)
  If CreateMenu(#Menu_0,WindowID(#Window_0))
   MenuTitle("File")
    MenuItem(1,"About")
     MenuBar()
    MenuItem(2,"Exit")
   MenuTitle("VNC Options")
    MenuItem(3,"Prompt user")
    MenuItem(4,"Disable remote input")
    MenuItem(5,"View only mode")
    MenuItem(6,"Remove wallpaper")
   MenuTitle("Program Options")
    MenuItem(7,"Sort hosts on exit")
     MenuBar()
    MenuItem(8,"Save window position")
     MenuBar()
    MenuItem(9,"Clear hosts list")
   CreatePopupMenu(#PopUp_Menu)
    MenuItem(10,"")
  EndIf
  ListIconGadget(#Hosts_List,10,10,380,300,"Host Name",150,#PB_ListIcon_AlwaysShowSelection|#PB_ListIcon_FullRowSelect)
   AddGadgetColumn(#Hosts_List,1,"Description",226)
   FillListIcon("hosts.dat")
   GadgetToolTip(#Hosts_List,"Double-click on a hostname to connect, right click to remove")
  TextGadget(#Text_HostName,10,322,150,20,"Host Name:")
   StringGadget(#String_HostName,75,320,200,20,"")
    GadgetToolTip(#String_Hostname,"Start typing to search hosts")
  TextGadget(#Text_Description,10,352,150,20,"Description:")
   StringGadget(#String_Description,75,350,200,20,"")
  ButtonGadget(#Connect_Button,290,330,100,30,"Connect")
   AddKeyboardShortcut(#Window_0,#PB_Shortcut_Return,11)
;}

;{ Set menu items accordingly
 If promptme=1
   flip3=1
    SetMenuItemState(#Menu_0,3,1)
 EndIf
  If noremote=1
    flip4=1
     SetMenuItemState(#Menu_0,4,1)
  EndIf
   If nolocal=1
     flip5=1
      SetMenuItemState(#Menu_0,5,1)
   EndIf
    If nowallpaper=1
      flip6=1
       SetMenuItemState(#Menu_0,6,1)
    EndIf
     If sorthosts=1
      flip7=1
       SetMenuItemState(#Menu_0,7,1)
     EndIf
      If savepos=1
       flip8=1
        SetMenuItemState(#Menu_0,8,1) 
      EndIf
;}

;{ Main program loop
Repeat

  event=WaitWindowEvent(1)
   FreeWorkingMemory()

;{ Disable Gadgets
   If CountGadgetItems(#Hosts_List)=0
     DisableGadget(#Hosts_List,1)
   Else
     DisableGadget(#Hosts_List,0)
   EndIf

   If GetGadgetText(#String_HostName) And GetGadgetText(#String_Description)<>""
     DisableGadget(#Connect_Button,0)
   Else
     DisableGadget(#Connect_Button,1)
   EndIf
;}

;{ Window Events
 Select event

   Case #PB_Event_Gadget
     eventgadget=EventGadget()
      eventtype=EventType()
       eventwindow=EventWindow()
;{ Gadget Events
     Select eventgadget

       Case #Connect_Button
         ConnectHostButton()

       Case #String_Hostname
         If EventType()=#PB_EventType_Change
           find.s = GetGadgetText(#String_Hostname)
            SearchListIcon(#Hosts_List, find)
         EndIf

     EndSelect
;}
;{ Mouse Events
     Select eventtype

       Case #PB_EventType_LeftDoubleClick

         If #Hosts_List
           ConnectHostMouse()
         EndIf

       Case #PB_EventType_RightClick

         If (#Hosts_List And GetGadgetText(#Hosts_List)<>"")
          SetMenuItemText(#PopUp_Menu,10,"Remove "+GetGadgetText(#Hosts_List)+" ?")          
           DisplayPopupMenu(#PopUp_Menu,WindowID(#Window_0))
         EndIf

     EndSelect
;}
;{ Menu Events
   Case #PB_Event_Menu

      Select EventMenu()

        Case 1;About
          aboutme.s = "Remote Control" + #CRLF$
		      aboutme   + "Dan Ford" + #CRLF$
          aboutme   + "oldnesjunkie@gmail.com" + #CRLF$
		      aboutme   + "Version 1.0"
          MessageRequester("About",aboutme,#MB_ICONINFORMATION)

        Case 2;Exit
          DeleteLocalFiles()
           End
  
        Case 3;Prompt User
          flip3=1-flip3
          If flip3=1
            SetMenuItemState(#Menu_0,3,1)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("PromptUser",1)
               ClosePreferences()
          Else
            SetMenuItemState(#Menu_0,3,0)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("PromptUser",0)
               ClosePreferences()
          EndIf

        Case 4;Disable Local Input
          flip4=1-flip4
          If flip4=1
            SetMenuItemState(#Menu_0,4,1)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("DisableRemoteInput",1)
               ClosePreferences()
          Else
            SetMenuItemState(#Menu_0,4,0)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("DisableRemoteInput",0)
               ClosePreferences()
          EndIf

        Case 5;Disable Remote Input
          flip5=1-flip5
          If flip5=1
            SetMenuItemState(#Menu_0,5,1)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("ViewOnly",1)
               ClosePreferences()
          Else
            SetMenuItemState(#Menu_0,5,0)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("ViewOnly",0)
               ClosePreferences()
          EndIf

        Case 6;Remove Wallpaper
          flip6=1-flip6
          If flip6=1
            SetMenuItemState(#Menu_0,6,1)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("RemoveWallpaper",1)
               ClosePreferences()
          Else
            SetMenuItemState(#Menu_0,6,0)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("RemoveWallpaper",0)
               ClosePreferences()
          EndIf

        Case 7;Sort hosts on exit
          flip7=1-flip7
          If flip7=1
            SetMenuItemState(#Menu_0,7,1)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("SortHosts",1)
               ClosePreferences()
          Else
            SetMenuItemState(#Menu_0,7,0)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("SortHosts",0)
               ClosePreferences()
          EndIf

        Case 8;Remember Last Position
          flip8=1-flip8
          If flip8=1
            SetMenuItemState(#Menu_0,8,1)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("SaveWindowPosition",1)
               ClosePreferences()
          Else
            SetMenuItemState(#Menu_0,8,0)
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("SaveWindowPosition",0)
               ClosePreferences()
          EndIf

        Case 9;Clear Hosts
          ClearHosts()

        Case 10;Remove Host
          RemoveHost()

        Case 11;Enter Key
          If GetGadgetText(#String_HostName)<>""
           If GetGadgetText(#String_Description)<>""
             ConnectHostButton()
              SetActiveGadget(#String_Description)
           EndIf
         EndIf

      EndSelect
;}

;{ Close Window Events
       Case #PB_Event_CloseWindow
         DeleteLocalFiles()
          If flip7=1
            SortFile("hosts.dat")
          EndIf
           If flip8=1
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("Lastx",WindowX(#Window_0))
               WritePreferenceInteger("LastY",WindowY(#Window_0))
               ClosePreferences()
           Else
             OpenPreferences("prefs.dat")
              WritePreferenceInteger("LastX",5)
               WritePreferenceInteger("LastY",5)
               ClosePreferences()
           EndIf
           End
;}

 EndSelect
;}
ForEver
;}

;{ Include binaries
DataSection

  viewerstart:
  IncludeBinary "VNCViewer\tvnviewer.exe"
  viewerend:

  serverstart:
  IncludeBinary "VNCServer\tvnserver.exe"
  serverend:

  hookloadstart:
  IncludeBinary "VNCServer\hookldr.exe"
  hookloadend:

  screenhookstart:
  IncludeBinary "VNCServer\screenhooks64.dll"
  screenhookend:

EndDataSection 
;}
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 17
; Folding = AAAAAAAAA+
; EnableXP
; UseIcon = icon.ico
; Executable = C:\Temp\RemoteControl.exe